KK=200;
delta=0.03; lambda=1; theta=1; c=2;
a1=0.02917305718455041525509308092552716230167;
a2=-0.485-a1;
C1=-.8941389842817982186856330514088361449301;
D1=lambda/(lambda+delta);
P=zeros(1,1);
P(1)=36.800509632421;
for N=1:KK;
    X=zeros(1,N);f=X; fs=X; g=X; gs=X; v=X; U=X;
    vs=X; vss=X; w=X; ws=X; F=X; Fs=X; Z=X; ZS=X; Hs=X; Y=X;
    X=P;
    for i=1:N
        x=X(i);
        f(i)=1-0.5*exp(-x/2);
        fs(i)=0.25*exp(-x/2);
        g(i)=1-exp(-x/2);
        gs(i)=1-f(i);
        v(i)=(1-C1)*exp(a1*x)+C1*exp(a2*x);
        vs(i)=(1-C1)*a1*exp(a1*x)+C1*a2*exp(a2*x);
        vss(i)=(1-C1)*a1^2*exp(a1*x)+C1*a2^2*exp(a2*x);
        w(i)=(lambda+delta)*v(i)/lambda-c*vs(i)/lambda;
        ws(i)=(lambda+delta)*vs(i)/lambda-c*vss(i)/lambda;
        F(i)=w/v; F1=F;
        Fs(i)=(ws(i)*v(i)-w(i)*vs(i))/v(i)^2;
        Z(i)=1/v(i);
        Zs(i)=-vs(i)/vs(i)^2;
        Hs(i)=gs(i)/g(i)-fs(i)/f(i);
    end;
    U(1)=D1*Z(1);
    for i=2:N
        U(i)=U(i-1)*D1*F(i)/Z(i-1)*Z(i);
    end
    A=sum(U(1:N));
    B=D1^(N-1)*prod(F(1:(N-1)))*Zs(N)/Hs(N);
    [A B]';
    step=0.01;
    a=X(N)+step;
    Ga=-10;
    while step>0.00000000000001;
        x=a-step;
        f=1-0.5*exp(-x/2);
        fs=0.25*exp(-x/2);
        g=1-exp(-x/2);
        gs=1-f;
        v=(1-C1)*exp(a1*x)+C1*exp(a2*x);
        vs=(1-C1)*a1*exp(a1*x)+C1*a2*exp(a2*x);
        vss=(1-C1)*a1^2*exp(a1*x)+C1*a2^2*exp(a2*x);
        w=(lambda+delta)*v/lambda-c*vs/lambda;
        ws=(lambda+delta)*vs/lambda-c*vss/lambda;
        F=w/v; F1=F;
        Fs=(ws*v-w*vs)/v^2;
        Z=1/v;
        Zs=-vs/vs^2;
        Hs=gs/g-fs/f;
        Ga=Fs*A+Zs-Hs*F*B;
        [a Ga];
        if Ga<0
            a=a-step;
        else
            step=step/2;
            % [a step Ga]'
        end;
    end
    P=zeros(1,N+1);
    P(2:N+1)=X;
    P(1)=a;
end;
P'
X=P;
uw=1-0.5*exp(-1);
for i=1:KK+1
    x=X(i);
    f=1-0.5*exp(-x/2);
    g=1-exp(-x/2);
    uw=uw*g/f;
end;
uw