clear;
format longEng;
S0=50; ds=1/500; S=0:ds:S0; KS=length(S);
da=1/1000; Alpha=da:da:1; KA=length(Alpha);
V=zeros(1,KS); Psi=V; W=V; H=V; v=V;M=v; VS=V;
Bi=zeros(1,500); ai=Bi;
lambda=1; c=2; delta=0.03; rho=1.2;
% delta=0; %for ruin probability
P=exp(-S);
p=[-diff(P) 0];
H=[c*rho*exp(-S) 0];
ReinsurMatrix;
Ad=find(H<c);
v(1)=1; vs=(lambda+delta)/c;
v(2)=v(1)+ds*vs;
M(1)=KS+1;
figure(2); hold off;
for i=2:KS-1
    if round(i/100)*100==i
        i
    end
    if M(i-1)<KS+1
        C1=find(Ad<M(i-1)+5 & Ad>M(i-1)-5);
        if length(C1)>0
            Ad1=Ad(C1);
        else
            Ad1=[Ad(find(Ad<=i)) KS+1];
        end
    else
        Ad1=[Ad(find(Ad<=i)) KS+1];
    end
    h=H(Ad1);
    VI=P0(Ad1,1:i-1)*v(i-1:-1:1)';
    [vs,j]=min(((lambda+delta)*v(i)-lambda*VI')./(c-h));
    M(i)=Ad1(j);
    v(i+1)=v(i)+ds*vs;
end;
M(KS)=M(KS-1);
VS(1:KS-1)=diff(v); VS(KS)=VS(KS-1);
figure(3); plot(S,VS); grid on;
[x,m]=min(VS/ds);
M1=m*ds;
Vs1=1-v(round(2/ds)+1)/v(KS);
Vs0=v(round(2/ds+1))/x;
phi1=1-v(round(2/ds)+1)/v(KS);
if delta>0
    f=zeros(1,KS);
    f(1)=1; fs=lambda/c; f(2)=f(1)+fs*ds;
    for s=2:KS-1
        if M(s)>s+1
            g=p(1:s-1)*f(s-1:-1:1)';
            c1=c;
        else
            g=P0(M(s),1:s-1)*f(s-1:-1:1)';
            c1=c-H(s);
        end
        fs=lambda*(f(s)-g)/c1;
        f(s+1)=f(s)+fs*ds;
    end
    d=f(KS); f=f/d;
    phi2=1-f(round(2/ds)+1);
    figure(4); plot(S,f); grid on;
    % clear P0;
    % save('Reinsurance500a.mat');
end