clear;
figure(1); hold off;
LundbergModel;
V2=zeros(KS,KA);
% load('LundbergIter100_500_150');
for L=1:50
    t=cputime;
    M=zeros(1,KA);
    for s=1:KS-1
        for al=max(round(Psi(s)/da),1):KA-1
            Feld=zeros(1,KS);
            alpha=al*da;
            for B=s:KS
                381 x1=(Psi(s)-Psi(B))/(1-Psi(B));
                x2=1-x1;
                x=(alpha-x1)/x2*KA;
                aB=floor(x);
                aB1=x-aB;
                if aB==0
                    VF=aB1*V1(B,aB+1);
                end
                if aB>0
                    VF=V1(B,aB)+aB1*(V1(B,aB+1)-V1(B,aB));
                end
                Feld(B-s+1)=W(s)/W(B)*VF;
            end
            x=max(Feld);
            if s>1
                y=V2(s-1,al)+ds;
                if (Psi(s-1)<alpha) & (x<y)
                    V2(s,al)=y;
                    if M(al)==0
                        M(al)=s;
                    end
                else
                    V2(s,al)=x;
                end
            end
        end
    end
    V2(:,KA)=V0;
    V1=V2;
    [L cputime-t V2(s0,alpha0) V2(s0,KA)]'
    figure(1); plot(Alpha,V2(s0,:)); hold on; grid on;
    drawnow;
end
save('LundbergIter50_500_150');